;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                      ;
;              L'Ultime Poker pour Ash 3.0 ~ version 2 ~               ;
;                                                                      ;
;                   (c) 1997 - Nicolas Hannebicque                     ;
;                                                                      ;
;                       < nhannebi@ireste.fr >                         ;
;                                                                      ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; dernire mise  jour : mercredi 28 janvier 1998, 21 h 59
; L'Ultime Poker version 3

; commentaires :
; * version sans bug pour les grands scores
; * version sans bug pour le BUSY_OFF ????
; * version sans bug pour le ROM_CALL/call FIND_PIXEL
; * changement de la routine alatoire

; Si vous utilisez des bouts de cette source, merci d'en indiquer la provenance.
; Cette source est galement trs commente. Toutefois, si vous ne comprenez pas
; un truc ou si ce truc est mal expliqu, n'hsitez pas  m'crire (courrier
; lectronique ou courrier normal)...
; Vous aurez remarqu que j'ai essay de bien faire la diffrence entre le NOMBRE hl
; et l'ADRESSE hl

	#include "TI82.h"
	#include "oldcall.h"
	#define show_pic(addr) ld hl,addr \ CALL_(show_picture) \ call GET_KEY \ or a \ jr nz,exit

	.org	START_ADDR
	.db	"L`Ultime Poker par oc",0

carte1		=	TEXT_MEM		; mmorise le numro de la carte n1
carte2		=	TEXT_MEM+1		; -------------------------------n2
carte3		=	TEXT_MEM+2		; etc
carte4		=	TEXT_MEM+3		;
carte5		=	TEXT_MEM+4		;
hasard		=	TEXT_MEM+10		; variable temporaire pour le random plus bas
garde1		=	TEXT_MEM+11		; mmorise si la carte n1 est garde : boolen
garde2		=	TEXT_MEM+12		; ---------------------n2---------------------
garde3		=	TEXT_MEM+13		; etc
garde4		=	TEXT_MEM+14		; 
garde5		=	TEXT_MEM+15		; 
score			=	TEXT_MEM+16		; score : mot (0-32767)
couleur1		=	TEXT_MEM+18		; indique la couleur de la carte n1
couleur2		=	TEXT_MEM+19		; -------------------------------n2
couleur3		=	TEXT_MEM+20		; etc
couleur4		=	TEXT_MEM+21		;
couleur5		=	TEXT_MEM+22		;
figure1		=	TEXT_MEM+23		; indique la figure de la carte n1
figure2		=	TEXT_MEM+24		; ------------------------------n2
figure3		=	TEXT_MEM+25		; etc
figure4		=	TEXT_MEM+26		;
figure5		=	TEXT_MEM+27		;
compteur_fig	=	TEXT_MEM+28		; indique le nombre d'galits entre les cartes
compt_quinte	=	TEXT_MEM+29		; " s'il y a une quinte, une quinte royale ou rien
compt_couleur	=	TEXT_MEM+30		; " s'il y a une couleur
coup			=	TEXT_MEM+31		; nombre de coups (0  9)
mise			=	TEXT_MEM+32		; mise : mot
var_temp		=	TEXT_MEM+38		; sert pour l'affichage numrique en petits caractres (6 octets [33..39])
gain			=	TEXT_MEM+40		; gain : mot
place_temp		=	TEXT_MEM+42		; 12 octets
randvar		=	TEXT_MEM+54		; variable alatoire
jeu_de_cartes	=	TEXT_MEM+55

debut:
	res	1,(iy+$0D)				; pour ne pas altrer la mmoire TEXT_MEM quand on crit
	ld	a,$8C			; met la page de la ROM  4 pour permettre
	out	(2),a			; l'utilisation de FIND_PIXEL
	CALL_(nettoie_le_jeu)
	ROM_CALL(CLEARLCD)	; explicite je pense

	CALL_(presentation)	; appelle l'cran de dpart (le "4 niveaux de gris")

nouvelle_partie:			; explicite
	ld	a,r			; charge dans la variable alatoire
	ld	(randvar),a		; le registre "Memory Refresh", un registre pseudo-alatoire
	CALL_(ecran_jeu)		; enregistre "le squelette" dans la mmoire graphique
	ld	a,10			; charge le score  10
	ld	(score),a		; 
	ld	a,0			;
	ld	(score+1),a		;
	ld	a,-1			; charge ne nb de coups  -1. -1??? Ben oui on va l'incrmenter
	ld	(coup),a		; juste aprs... (ouais, pour moins de contraintes je compte de 0  9)

nouveau_tour:			; explicite
	ld	b,5			; met 5 dans b
	ld	de,couleur1		; de pointe couleur1
	ld	hl,figure1		; hl pointe figure1
tour_init:				; initialisation de dbut de tour
	ld	(hl),14		; met 14 dans (figure1) (14 n'est pas une bonne figure mais elle
					; permet d'afficher des phis dans les cartes)
	ld	a,5			; met 5  dans (couleur1) (5 n'est pas une bonne couleur non plus
	ld	(de),a		; mais a permet d'afficher des phis aussi)
	inc	hl			; hl pointe maintenant figure2
	inc	de			; de pointe couleur2
	djnz	tour_init		; recommence 5 fois
	ld	b,5
	ld	hl,garde1		; hl pointe garde1
tour_init2:				; on met dans les garde[i] 0, pour indiquer
	ld	(hl),0		; que les cartes ne sont pas gardes
	inc	hl
	djnz	tour_init2

	CALL_(afficher_cartes)	; explicite
	CALL_(afficher_textes)	; affiche les textes tels que score, gain, etc
	ld	a,(coup)		; incrmente
	inc	a			; le nombre
	ld	(coup),a		; de coups
	CALL_(maj_coup)		; maj=mise  jour=update, OK ? donc ici maj des coups ( l'cran)
	CALL_(maj_score)		; du score
	ld	hl,gain		; RAZ
	ld	(hl),0		; du
	inc	hl			; gain
	ld	(hl),0		; puis
	CALL_(maj_gain)		; maj

boucle_mise_bis:			; boucle plus complte que boucle_mise, o l'on introduit la mise
	ld	b,0			; b compte le nombre de chiffres entrs, ici 0
	ld	hl,0			; RAZ de la mise
	ld	(mise),hl		;
	CALL_(maj_mise)		; puis maj
boucle_mise:			; boucle principale si l'utilisateur ne fait pas de conneries
	ld	a,b			; regarde si l'on a tap 6 chiffres
	cp	6			; si oui erreur de l'utilisateur
	jr	z,boucle_mise_bis	; donc on va dans boucle_mise_bis
	call	GET_KEY		; regarde la touche tape
	or	a			; la rappelle
	cp	55			; la compare  55 (MODE)
	ret	z			; si c'est gal, retourne dans Ash
	cp	56			; si c'est DEL, recommence depuis le dbut
	jr	z,boucle_mise_bis	; 
	cp	34			; si c'est 1, va  mise1
	jr	z,mise1		; 
	cp	26			; etc
	jr	z,mise2
	cp	18
	jr	z,mise3
	cp	35
	jr	z,mise4
	cp	27
	jr	z,mise5
	cp	19
	jr	z,mise6
	cp	36
	jr	z,mise7
	cp	28
	jr	z,mise8
	cp	20
	jr	z,mise9
	cp	33
	jr	z,mise0
	cp	47			; intressant : si l'on appuie sur MATH, affiche le truc bidon
	CALL_Z(vla_le_prof)	; puis revient (CALL fait revenir  l'endroit d'o on est parti)
	cp	9			; si c'est ENTER, la mise est OK
	jr	z,mise_ok		;
	jr	boucle_mise		; si l'on a pas trouv ce qu'on a tap, on retourne l-haut
mise1:				; met 1 dans a
	ld	a,1			;
	jr	misex			; va  l'endroit de convergence
mise2:				; etc
	ld	a,2
	jr	misex
mise3:
	ld	a,3
	jr	misex
mise4:
	ld	a,4
	jr	misex
mise5:
	ld	a,5
	jr	misex
mise6:
	ld	a,6
	jr	misex
mise7:
	ld	a,7
	jr	misex
mise8:
	ld	a,8
	jr	misex
mise9:
	ld	a,9
	jr	misex
mise0:
	ld	a,0
misex:				; tout le monde se retrouve ici...
	ld	d,a			; sauve a dans d
	inc	b			; incrmente le nombre de chiffres taps
	ld	a,b			; compare  6
	cp	6			; si c'est 6 on retourne l-haut
	jr	z,boucle_mise	;
	ld	a,d			; restaure a
	push	bc			; sauve bc
	push	af			; sauve af=a+les bits d'tat
	ld	a,(mise+1)		; ac reprsente la mise actuelle (en cours d'criture)
	ld	c,a
	ld	a,(mise)
	ld	de,10			; de est  10
	CALL_(mult16)		; on effectue ac*de en 16 bits. Le rsultat est dans hl
	pop	af			; on restaure a et f
	ld	b,0			; on met dans bc le nombre a, ie le chiffre tap au clavier
	ld	c,a
	add	hl,bc			; on l'additionne avec le rsultat de l'addition (mise=10*mise+a)
	ld	(mise),hl		; on "sauve la mise" (!)
	ld	d,25			; entre en d et e
	ld	e,66			; les coordonnes du curseur graphique (d=ord, e=abs)
	CALL_(D_ZM_M_STR)		; affiche le nombre hl (16 bits)  cet endroit
	pop	bc			; restaure bc
	JUMP_(boucle_mise)	; retourne pour prendre la touche suivante
mise_ok:				; mise ok
	ld	a,(mise)		; si les 8 premiers bits de
	cp	0			; mise sont diffrents de zro, c'est bon
	jr	nz,mise_ok_bis	;
	ld	a,(mise+1)		; sinon si les 8 bits de poids forts sont tous
	cp	0			; nuls, c'est pas bon
	JUMP_Z(boucle_mise)	; donc on retourne
mise_ok_bis:			; mise ok et non nulle
	ld	hl,(mise)		; compare la mise au score
	ld	de,(score)		; par une routine de la ROM qui compare
	call	CP_HL_DE		; 2 nombres de 16 bits
	JUMP_Z(mise_ok_ter)	; s'ils ont gaux, c'est bon
	JUMP_NC(boucle_mise_bis); sinon on retourne l-haut
mise_ok_ter:			; le final pour la mise
	ld	hl,(score)		; soustraction 16 bits
	ld	de,(mise)		; <=> score=score-mise
	and	a			; met la retenue (carry flag)  0
	sbc	hl,de			; soustrait avec la retenue hl et de
	ld	(score),hl		; mmorise le rsultat

tirage1:				; 1 tirage
	CALL_(maj_score)		; mise  jour du score
	ld	b,5			; tire 5 nombres
boucle1:				; 
	CALL_(random)		; tire au hasard un nombre entre 1 inclus et 52 inclus
	ld	(hasard),a		; mmorise ce nombre  l'adresse hasard
	ld	hl,TEXT_MEM		; sinon on met en mmoire la carte
	CALL_(mise_en_mem)	;  l'adresse adquate
	djnz	boucle1		; recommence 5 fois

	CALL_(decryptage_carte)	; dcrypte les cartes (spare les figures et les couleurs
					; du numro seul qui est inexploitable)
	CALL_(afficher_cartes)	; affiche les cartes
	CALL_(afficher_textes)	; affiche les textes

saisie_touches:			; saisie les touches, c'est marqu !!!
	call	GET_KEY		; c'est utile de le marquer ?
	or	a			; on rappelle l'accumulateur a
	cp	55			; le compare  55 (MODE)
	ret	z			; s'en va si c'est gal
	cp	47			; MATH? => V'l le prof
	CALL_Z(vla_le_prof)	; 
	cp	53			; Y=? on garde le premire carte
	jr	z,garde_1		;
	cp	52			; WINDOW ?
	jr	z,garde_2		; etc
	cp	51
	jr	z,garde_3
	cp	50
	jr	z,garde_4
	cp	49
	jr	z,garde_5
	cp	9			; ENTER valide la combinaison
	jr	z,combinaison_ok	;
	jr	saisie_touches	; sinon on retourne en haut

garde_1:
	ld	c,1			; on met dans c le numro de la carte  garder
	jp	general
garde_2:
	ld	c,2
	jp	general
garde_3:
	ld	c,3
	jp	general
garde_4:
	ld	c,4
	jp	general
garde_5:
	ld	c,5
general:				; inverse "l'tat de garde" de la carte : si elle tait garde,
	ld	b,0			; elle ne l'est plus, sinon elle l'est
	ld	hl,TEXT_MEM+10	; pointe les garde[i], en l'occurence garde1
	add	hl,bc			; on additionne bc  hl, comme a hl pointe vers le bon garde[i]
	ld	a,(hl)		; on rappelle le garde[i] en question dans a
	cp	1			; si garde[i]=1, on le met  0 dans inverse
	jr	z,inverse
	push	hl			; sinon on le met  1, et on affiche "Hold"
	CALL_(affich_hold)
	pop	hl
	ld	(hl),1
	jr	saisie_touches	; on retourne  la saisie des touches
inverse:				; on met un 0 dans garde[i]
	push	hl			; on affiche "Rien"
	CALL_(affich_rien)
	pop	hl
	ld	(hl),0
	jr	saisie_touches	; et on remonte


combinaison_ok:			; la combinaison nous plat
	ld	b,5			; on va transfrer les cartes de carte[i]  carte_prec[i]
	ld	hl,TEXT_MEM+5	; 
	ld	de,TEXT_MEM		;
transfert_cartes:			; transfre les cartes pour ne pas qu'on les reprenne
	ld	a,(de)		; d'un tour sur l'autre
	ld	(hl),a		; transfre donc (de) dans (hl)
	inc	de			; puis incrmente les adresses
	inc	hl			;
	djnz	transfert_cartes	; fait cela 5 fois
	ld	d,5			; charge d  5 pour excuter 5 fois ce qui suit
boucle2:
	ld	b,d			; transfert vers b
	push	de			; sauve de
boucle3:				; tire au sort les cartes non gardes telles
	ld	a,6			; qu'elles soient diffrentes de celles qu'on
	sub	b			; a jetes
	push	bc			; calculs un peu bourrins, que j'optimiserai ultrieurement
	add	a,10			; pour accder  la bonne adresse garde[i]
	ld	c,a
	ld	b,0
	ld	hl,TEXT_MEM
	add	hl,bc
	pop	bc
	ld	a,(hl)		; si (garde[i])=1
	cp	1			; on va plus loin
	jp	z,plus_loin
	CALL_(random)		; sinon on tire au hasard un nombre
	ld	(hasard),a
	ld	hl,TEXT_MEM		; sinon on le garde et on 
	CALL_(mise_en_mem)	; le met en mmoire
	pop	de			; on restaure de, plus particulrement d notre compteur
	dec	d			; on le dcrmente
	jr	nz,boucle2		; s'il n'est pas gal  0 en continue  piocher au hasard
	JUMP_Z(suite)		; sinon on continue l'ordre
plus_loin:				; si on n'a pas besoin de tirer de nouvelle carte
	pop	de			; on restaure de, d en particulier
	dec	d			; on le dcrmente
	jr	nz,boucle2		; et teste si c'est la dernire carte ou non

suite:				; les cartes ont t tires avec succs
	CALL_(decryptage_carte)	; on les dcrypte
	CALL_(afficher_cartes)	; on les affiche
	CALL_(afficher_textes)	; on affiche les textes

traitement_fig:			; teste si on a une paire, une double paire, un brelan, un full,
	ld	a,0			; un carr
	ld	(compteur_fig),a	; on initialise (compteur_fig)  0
	ld	hl,TEXT_MEM+22	; on pointe figure1-1
	ld	b,4			; on ritre 4 fois
premiere_boucle:			; 
	inc	hl			; on pointe maintenant figure[i]
	push	bc			; sauvegarde bc
	ld	d,h			; copie hl dans de
	ld	e,l			;
deuxieme_boucle:			;
	inc	de			; incrmente de=figure[j]
	ld	a,(de)		; compare
	ld	c,a			; figure[i]
	ld	a,(hl)		; et
	cp	c			; figure[j]
	jr	nz,plus_loin2	; si elles ne sont pas gales, on va plus bas
	ld	a,(compteur_fig)	; sinon on incrmente notre compteur
	inc	a			; 
	ld	(compteur_fig),a	;
plus_loin2:				; recommence pour i=4..1
	djnz	deuxieme_boucle	; et j=i..1
	pop	bc			;
	djnz	premiere_boucle	;

traitement_suite:			; trier les cartes : mthode du tri par bulle...
	ld	b,4			; compteur  4
tri1:					; 
	push	bc			; sauvegarde bc
	ld	hl,TEXT_MEM+22	; pointe figure1-1
	ld	de,TEXT_MEM+23	; pointe figure1
	ld	b,4			; compteur  4
tri2:					;
	inc	hl			; on incrmente les 2 adresses
	inc	de			;
	ld	c,(hl)		; compare leurs contenus
	ld	a,(de)		;
	cp	c			;
	jr	nc,en_bas		; si (hl)<(de) on ne change rien
	ld	(hl),a		; sinon
	ld	a,c			; on intervertit
	ld	(de),a		; les 2 nombres
en_bas:				; 
	djnz	tri2			; recommence pour i=1..4
	pop	bc			; et j=1..4
	djnz	tri1			; (temps trs long pour cette mthode sauf en asm et pour 5 valeurs !!)

	ld	hl,TEXT_MEM+23	; hl pointe la premire figure (la plus petite)
	ld	de,TEXT_MEM+24	; de vers la 2 plus petite
	ld	b,4			; on ritre 4 fois
loop1:				;
	push	bc			; sauvegarde du compteur
	ld	a,(de)		; compare
	ld	b,(hl)		; (de)-1
	dec	a			; et
	cp	b			; (hl)
	jr	nz,pas_bon		; s'ils ne sont pas gaux on dgage de l !
	pop	bc			; on dpile bc
	inc	de			; on incrmente de et hl pour qu'ils pointent vers
	inc	hl			; les 2 nombres suivants  comparer
	djnz	loop1			; recommence 4 fois

	ld	hl,TEXT_MEM+23	; quand c'est fini on teste si la premire figure
	ld	a,(hl)		; est un as
	cp	1			; si non, on n'a pas de quinte royale
	jr	nz,bon		; si oui on l'a
	ld	a,2			; et on met 2 dans a
	jr	farer			; et on dgage plus loin
bon:
	ld	a,1			; on n'a qu'une quinte
	jr	farer			; => a=1
pas_bon:
	pop	bc			; on dpile bc ! SINON MEGA-CRASH DE LA MORT !
	ld	a,0			; on n'a pas de quinte du tout
farer:
	ld	(compt_quinte),a	; on mmorise le compteur de quinte

	ld	de,TEXT_MEM+18	; pointe vers la premire couleur
	ld	hl,TEXT_MEM+19	; pointe vers la deuxime couleur
	ld	b,4			; il y a 4 tests  faire
traitement_coul:			;
	push	bc			; sauvegarde du compteur
	ld	a,(de)		; compare les 2 couleurs
	ld	b,(hl)		;
	cp	b			;
	jr	nz,mauvais		; si elles ne sont pas gales on s'en va
	inc	hl			; on incrmente nos adresses
	inc	de			;
	pop	bc			; on remet b
	djnz	traitement_coul	; on boucle
	ld	a,1			; si on a fini, c'est qu'il y a une couleur
	jr	next			; on va le mmoriser
mauvais:
	pop	bc			; on dpile, SINON CRASH toujours, ATTENTION, c'est une erreur
	ld	a,0			; courante au dbut !! a=0 car il n'y a pas de couleur
next:
	ld	(compt_couleur),a	; ok, on mmorise

	CALL_(traite_result)	; traitement du rsultat
	CALL_(maj_gain)		; mise  jour du gain
	CALL_(maj_score)		; mise  jour du score
	CALL_(attendre)		; attendre su'une touche soit presse
	or	a			; on la rappelle
	cp	55			; si c'est MODE
	ret	z			; on quitte
	cp	47			; si c'est MATH
	CALL_Z(vla_le_prof)	; V'l le prof
	CALL_(eff_resultat)	; on efface le rsultat et les inscriptions Hold
	ld	a,(coup)		; si on est au 9 coup on va  la fin
	cp	9			;
	jr	z,fin			;
	ld	hl,(score)		; on charge on hl le score (16 bits)
	ld	de,0			; on met 0 dans de
	call	CP_HL_DE		; on les compare
	JUMP_NZ(nouveau_tour)	; si la diffrence n'est pas nulle on fait un nouveau tour
fin:
	ld	hl,(score)		; compare le score  0
	ld	de,0			; si le score n'est pas nul,
	call	CP_HL_DE		; on va  gagne
	CALL_NZ(gagne)
	CALL_Z(perdu)		; sinon  perdu
wait:					; on attend qu'une
	CALL_(attendre)		; touche
	or	a			; soit presse
	cp	9			; ENTER => nouvelle partie
	JUMP_Z(nouvelle_partie)	;
	cp	55			; MODE => quitter
	ret	z			;
	jr	wait			; boucle
	ret				; retour final (inutile je pense d'ailleurs)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; procdures annexes (non incluses dans l'ordre linaire du prog). ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

perdu:				; vient ici si l'on a perdu
	CALL_(affiche_meilleur)
	ret				; retourne

gagne:
	push	af			; sauvegarde le contenu de f en particulier
	ld	hl,(score)		; compare le score
	ld	de,(moins_bon)	; et le moins bon des meilleurs scores
	call	CP_HL_DE		; compare les valeurs hl et de
	jr	c,gagne_seul	; s'il est infrieur ou gal, va 
	jr	z,gagne_seul	; gagn seulement
	ld	(moins_bon),hl	; charge le nouveau score en tant que moins bon score
	ld	hl,moins_bon+2	; pointe le nom du dernier high-score
	CALL_(entree_nom)		; rentre le nom de (l'heureux ?) joueur
	CALL_(reclasse)		; reclasse les scores
	CALL_(affiche_meilleur)	; affiche les meilleurs scores
	pop	af			; restaure f
	ret

gagne_seul:
	CALL_(affiche_meilleur)
	pop	af			; on restitue  a et f leurs valeurs
	ret				; retourne

affiche_meilleur:			; affiche ce qu'on appelle communment les high-scores
	ROM_CALL(CLEARLCD)	; faciiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiile :)
	ld	hl,$0000		; curseur
	ld	($800C),hl		; texte
	ld	hl,msg_meilleurs	; pointe le message du haut
	set	3,(iy+$5)		; met en blanc sur noir
	ROM_CALL(D_ZT_STR)	; affiche la chane
	ld	b,5			; 5 scores  afficher
	ld	hl,hauts_scores	; pointe les hauts scores
	ld	de,$0000		; met 0 dans de qui servira de position du curseur texte
bouboucle:				; dlire perso (il faut bien pter les plombs de temps en temps)
	push	bc			; sauve le compteur b
	inc	de			; incrmente la position du curseur d'1 en ordonne
	push	de			; la sauve
	push	hl			; sauve l'adresse du high score courant
	bit	3,(iy+$5)		; change la couleur
	jr	z,apres		; du texte
	res	3,(iy+$5)		;  afficher
	jr	apres2		; regardez de plus prs
apres:				; c'est
	set	3,(iy+$5)		; comprhensible
apres2:
	push	hl			; resauve cette adresse
	inc	hl			; l'incrmente
	inc	hl			; re
	ld	($800C),de		; position du curseur texte
	ROM_CALL(D_ZT_STR)	; affiche le nom du high-score courant
	ld	a,d			; ajoute
	add	a,$0B			; 11
	ld	d,a			;  l'abscisse
	ld	($800C),de		; du curseur texte
	pop	hl			; restaure l'adresse initiale du high-score courant
	ld	e,(hl)		; met dans de
	inc	hl			; le nombre
	ld	d,(hl)		; contenu  l'adresse hl
	ld	h,d			; transfert ensuite le
	ld	l,e			; nombre de dans hl
	ROM_CALL(D_HL_DECI)	; affiche le nombre hl
	pop	hl			; restaure hl
	ld	bc,12			; met 12 dans bc
	add	hl,bc			; ajoute 12  l'adresse hl pour pointer le score suivant
	pop	de			; restaure le curseur texte
	pop	bc			; restaure le compteur
	djnz	bouboucle		; boucle
	set	3,(iy+$5)		; texte en blanc sur noir
	ld	hl,$0106		; affiche
	ld	($800C),hl		; les
	ld	hl,msg_fin1		; messages
	ROM_CALL(D_ZT_STR)	; de fin
	ld	hl,$0207		; ...
	ld	($800C),hl
	ld	hl,msg_fin2
	ROM_CALL(D_ZT_STR)
	res	3,(iy+$5)
	ret

reclasse:				; classe les scores dans l'ordre
	ld	b,4			; mthode du tri par bulle, comme pour le tri des figures
tri_bulle1:				; 2 boucles qui se rptent chacune 4 fois
	push	bc			; sauve le compteur
	ld	hl,hauts_scores-12; pointe le premier high-score - 12 octets
	ld	de,hauts_scores	; pointe le premier high-score
	ld	b,4			; compteur  4
tri_bulle2:				; 2me boucle
	push	bc			; sauve compteur
	ld	bc,12			; ajoute
	add	hl,bc			;  l'adresse hl
	push	hl			; 12 puis sauve hl
	ex	de,hl			; pour ajouter 12  de,
	ld	bc,12			; on change pour calculer avec hl
	add	hl,bc			; on ajoute  hl bc
	ex	de,hl			; puis on remet le rsultat en de
	pop	hl			; on restaure hl
	push	de			; on sauve de
	push	hl			; on sauve hl
	push	de			; sauvegardes...
	push	hl			;
	push	bc			;
	ld	b,h			; compare
	ld	c,l			; les
	ld	a,(bc)		; paires
	ld	l,a			; de 
	inc	bc			; registres
	ld	a,(bc)		; hl
	ld	h,a			; et
	ld	b,d			; de
	ld	c,e			; |
	ld	a,(bc)		; |
	ld	e,a			; |
	inc	bc			; V
	ld	a,(bc)
	ld	d,a
	push	hl
	ld	h,d
	ld	l,e
	pop	hl
	ex	de,hl
	call	CP_HL_DE
	jr	c,plus_bas
	pop	bc			; dpope, etc
	pop	hl
	pop	de
	push	hl
	push	de
	ex	de,hl			; copie le score 2 dans l'espace temporaire imparti
	ld	de,place_temp	; 12 octets  copier (10 de nom + 2 de score)
	ld	bc,12
	ldir
	pop	de
	pop	hl
	push	de			; copie le score 1 dans le score 2
	push	hl			; mme principe
	ld	bc,12
	ldir
	pop	hl
	pop	de
	ex	de,hl			; copie l'espace temporaire dans le score 1
	ld	hl,place_temp
	ld	bc,12
	ldir				; voyez les notes relatives  la fonction ldir : trs utile
	jr	plus_bas2		; quand on veut copier une zone mmoire vers une autre
plus_bas:
	pop	bc
	pop	hl
	pop	de
plus_bas2:
	pop	hl			; dpile tout ce qu'on avait empil sinon CRASH !!!!!!
	pop	de			; boucle l o il faut boucler
	pop	bc			; etc...
	djnz	tri_bulle2
	pop	bc
	djnz	tri_bulle1
	ret

vla_le_prof:			; fonction explicite, pour nous francophones...
	ROM_CALL(BACKUP_DISP)	; fonction dont je ne m'tais jamais servi avant. Fait un backup
					; de la mmoire graphique dans la mmoire apdbuf
	ROM_CALL(CLEARLCD)	; ckoidon ??
	ld	hl,0			; curseur texte
	ld	($800C),hl		;
	ld	hl,msg_prof		; hl pointe vers notre solve(sin X,X,0)
	ROM_CALL(D_ZT_STR)	; affiche la chane
vla_le_prof2:			; boucle d'attente
	CALL_(attendre)		; attend en effet
	or	a			; rappelle la valeur de la touche presse
	cp	47			; si c'est pas MATH,
	jr	nz,vla_le_prof2	; on boucle
	ROM_CALL(RESTOR_DISP)	; sinon on restaure l'cran de jeu par un restore. Facile non ?
	ret				; retourne

eff_resultat:			; efface les rsultats et les Hold au bas de l'cran
	ld	b,65			; 65 itrations  faire
	ld	d,18			; position
	ld	e,30			; du 
	ld	($8215),de		; curseur graphique
	set	7,(iy+$14)		; permet l'affichage du texte non pas directement sur l'cran mais
					; dans la mmoire graphique. J'ai appris a il y a 3 jours. Sans a
					; c'est sr, c'tait dur (dans Master Mind j'ai d ruser...)
eff_res_loop:			; 
	ld	a,' '			; a est le caractre  afficher, en l'occurence un espace !
	ROM_CALL(M_CHARPUT)	; l'affiche
	djnz	eff_res_loop	; boucle (c'est tout car les positions sont mises  jour automatiquement)
	ld	b,96			; puis dans le bas y a 96 itrations sur le mme principe
	ld	d,57			; ...
	ld	e,0
	ld	($8215),de
eff_res_loop2:
	ld	a,' '
	ROM_CALL(M_CHARPUT)
	djnz	eff_res_loop2
	res	7,(iy+$14)		; arrte l'criture dans la mmoire graphique
	ROM_CALL(DISP_GRAPH)	; et si l'criture est dans la mmoire graphique, il faut l'afficher
	ret				; sinon on ne voit pas les modifications...

maj_gain:				; mise  jour du gain
	ld	hl,(gain)		; charge le gain dans hl (16 bits)
	ld	d,11			; position graphique : y=11,
	ld	e,66			; x=66
	CALL_(D_ZM_M_STR)		; affiche le gain  l'cran
	ret				; retourne

maj_score:				; idem avec le score...
	ld	hl,(score)
	ld	d,11
	ld	e,23
	CALL_(D_ZM_M_STR)
	ret

maj_mise:				; idem avec la mise...
	ld	hl,(mise)
	ld	d,25
	ld	e,66
	CALL_(D_ZM_M_STR)
	ret

maj_coup:				; pour les coups c'est plus spcial
	ld	a,(coup)		; charge (coup) dans a (8 bits bien sr)
	add	a,48			; ajoute le dcalage ascii
	ld	d,25			; position graphique y=25,
	ld	e,19			; x=19
	ld	($8215),de		; mmorise cette position graphique
	set	7,(iy+$14)		; permettre l'criture en mmoire
	ROM_CALL(M_CHARPUT)	; afficher a (1 seul caractre) => vous imaginez pourquoi je n'ai
					; pris les coups que de 0  9...
	res	7,(iy+$14)		; ne plus permettre l'criture en mmoire
	ROM_CALL(DISP_GRAPH)	; afficher les nouveauts de la mmoire garphique
	ret				; retourne


; Merci  Jimmy Mrdell pour cette routine...
D_ZM_M_STR:				; affiche le contenu en petits caractres hl (nb de 16 bits)
	push	bc			; sauve bc (on en a besoin dans la fonction appelante)
	push	de			; 5 chiffres  afficher (log(2^15-1)<5)
	ld	b,5			; on affiche  l'endroit x=e et y=d qu'on sauve avec push
	ld	de,var_temp		; on pointe var_temp avec de
	set	7,(iy+$14)		; texte dans la mmoire graphique
d_zm_m_str_loop:
	call	UNPACK_HL		; fonction de la ROM qui permet de convertir le nombre hl en une
					; suite de chiffres. Fonctionne de droite  gauche, ie les units
					; d'abord, puis les dizaines, etc... Stocke ce chiffre dans a.
					; Alors elle est pas belle la vie ??
	add	a,$30			; ajoute  a le dcalage ascii
	ld	(de),a		; le met dans notre variable temporaire
	dec	de			; dcrmente son adresse pour le prochain chiffre
      djnz	d_zm_m_str_loop	; boucle pour le deuxime chiffre, etc...
	ld	a,0			; affiche un caractre sentinelle ('\0')
	ld	(var_temp+1),a	;  la fin de la chane de chiffres
	inc	de			; de est au dessous de l'adresse de la chane  afficher (y a eu
					; un dec de trop...) donc on incrmente de.
	ex	de,hl			; change hl et de (pour l'affichage de la chane)
	pop	de			; on redonne  de la position graphique
	ld	($8215),de		; et on la mmorise
	ROM_CALL(D_ZM_STR)	; on affiche la chane
	ROM_CALL(DISP_GRAPH)	; affiche la mmoire graphique
	res	7,(iy+$14)		; fin d'criture en mmoire
	pop	bc			; restaure bc
	ret				; retourne

mult16:				; multiplication 16 bits trouve
	ld	b,16			; dans le livre Programmation du
	ld	hl,0			; Z80, par Rodnay Zaks,
mult:					; ditions Sybex
	srl	c			; (multiplication de de par
	rra				; a & c regroups
	jr	nc,noadd		; rsultat dans hl)
	add	hl,de			; Franchement technique mais en jetant un oeil dans le bouquin
noadd:				; je viens de comprendre; srl c et rra dcalent d'un bit vers la
	ex	de,hl			; droite le bloc ac. Le bit le plus  droite est mis dans CY, le bit
	add	hl,hl			; d'tat de retenue. S'il n'est pas nul, c'est que le nombre tait
	ex	de,hl			; pair, donc on n'ajoute pas le multiplicande au rsultat hl, sinon
	djnz	mult			; on l'ajoute. Ensuite les 3 instructions qui suivent font dcaler
	ret				; de vers la droite d'un cran (=*2). Ensuite on boucle pour le bit
					; suivant et "Roulez Carosse", comme dirait un de mes profs, vous
					; pouvez tester, a marche...
traite_result:			; retour  des choses plus ordinaires et plus faciles
	ld	a,(compteur_fig)	; compare les diffrentes figures et traite en consquence
	cp	0			; suivant le rsultat qu'on a
	jr	z,result1		; s'il n'y a aucune galit entre les cartes, va plus bas
	cp	1
	jr	z,paire
	cp	2
	jr	z,dblpaire
	cp	3
	jr	z,brelan
	cp	4
	jr	z,full
	ld	hl,msg_carre	; si ce n'est pas un des 4, c'est carr => en hl le message
	ld	d,25			; => en a le gain
	jr	aff			; va en aff
full:					; etc...
	ld	hl,msg_full
	ld	d,12
	jr	aff
paire:
	ld	hl,msg_paire
	ld	d,1
	jr	aff
dblpaire:
	ld	hl,msg_dblpaire
	ld	d,2
	jr	aff
brelan:
	ld	hl,msg_brelan
	ld	d,3
	jr	aff
result1:				; on n'a pas eu de figure... Peut-tre une quinte ?
	ld	a,(compt_quinte)	; charge dans l'accumulateur a le compteur de quintes
	cp	0			; s'il n'y en a pas (pas de pot), va plus loin
	jr	z,result2
	cp	1			; s'il y a une quinte normale
	jr	z,quinte		; va  quinte
	ld	hl,msg_quinteroy	; sinon on a une quinte royale
	ld	d,50			; gain=*50
	jr	intermed		; va  intermed(iaire)
quinte:				; on a une quinte
	ld	hl,msg_quinte	; message et gain
	ld	d,6
intermed:				; regarde si on a une couleur en plus de la quinte
	ld	a,(compt_couleur)	; accumulateur=couleur
	cp	0			; si pas de couleur
	jr	z,aff			; va  aff
	ld	a,(compt_quinte)	; sinon si on a une quinte royale et une couleur
	cp	2			; va  qqqq
	jr	z,qqqq		;
	ld	hl,msg_quintecoul	; sinon on a une quinte normale et une couleur
	ld	d,20			; message et gain
	jr	aff			; va  aff
qqqq:
	ld	hl,msg_qroycoul	; on a une quinte royale et une couleur
	ld	d,80			; ...
	jr	aff
result2:				; peut-tre a-t-on seulement une couleur ?
	ld	a,(compt_couleur)	; si non, tant pis
	cp	0			; et va  result3
	jr	z,result3		; sinon tant mieux
	ld	hl,msg_couleur
	ld	d,10
	jr	aff
result3:				; c'est tout, l on n'a rien
	ld	hl,msg_quedalle	; pardonnez-moi le "Que dalle..." : dlire personnel
	ld	d,0			; pas de gain bien sr
aff:					; affiche le rsultat
	push	de
	ld	d,18			; position du curseur graphique
	ld	e,31
	ld	($8215),de
	set	7,(iy+$14)		; criture dans la mmoire
	ROM_CALL(D_ZM_STR)	; affichage
	res	7,(iy+$14)
	pop	de
	ld	a,d
	ld	c,0			; on met 0 dans c (bits de poids forts). a est dj prt pour la multiplication
	ld	de,(mise)		; on met (mise) dans de (16 bits)
	CALL_(mult16)		; fait la multiplication 16 bits pour avoir
	ld	(gain),hl		; le gain que voici voil
	ld	de,(score)		; charge (score) dans de
	add	hl,de			; on additionne le score et le gain...
	ld	(score),hl		; et on le sauve (normal non ?)
	ROM_CALL(DISP_GRAPH)	; affiche le rsultat
	ret

afficher_textes:			; trs simple : non comment.
	set	7,(iy+$14)
	ld	hl,$0B00
	ld	($8215),hl
	ld	hl,msg_score
	ROM_CALL(D_ZM_STR)
	ld	hl,$1200
	ld	($8215),hl
	ld	hl,msg_resultat
	ROM_CALL(D_ZM_STR)
	ld	hl,$1900
	ld	($8215),hl
	ld	hl,msg_coup
	ROM_CALL(D_ZM_STR)
	ld	hl,$1930
	ld	($8215),hl
	ld	hl,msg_mise
	ROM_CALL(D_ZM_STR)
	ld	hl,$0B30
	ld	($8215),hl
	ld	hl,msg_gain
	ROM_CALL(D_ZM_STR)
	res	7,(iy+$14)
	ROM_CALL(DISP_GRAPH)
	ret

afficher_cartes:			; explicite
	set	7,(iy+$14)		; crire dans la mmoire
	ld	b,5			; 5 cartes  traiter
	ld	c,0			; charge 0 dans c
	ld	hl,TEXT_MEM+18	; hl pointe la 1 couleur
coucou:				; pourquoi coucou ? De l'euphorie ce jour-l peut-tre...
	push	bc			; sauve b et c
	push	hl			; sauve hl
	ld	a,(hl)		; a est la couleur de la i carte
	cp	1			; suivant le numro que c'est on va plus ou moins loin...
	jr	z,stade1
	cp	2
	jr	z,stade2
	cp	3
	jr	z,stade3
	cp	4
	jr	z,stade4
	ld	hl,pic_init		; si au bout des 4 couleurs normales on a pas trouv, c'est qu'il 
	jr	stade5		; s'agit du phi
stade1:				; carreau...
	ld	hl,pic_carreau	; ...
	jr	stade5
stade2:
	ld	hl,pic_trefle
	jr	stade5
stade3:
	ld	hl,pic_coeur
	jr	stade5
stade4:
	ld	hl,pic_pique
stade5:				; affiche
	ld	a,c			; c=a
	sla	a			; a=2c
	sla	a			; a=4c
	sla	a			; a=8c
	sla	a			; a=16c
	add	a,c			; a=17c
	sla	c			; c=2c
	add	a,c			; a=19c
	add	a,10			; a=19c+10
	ld	b,a			; a abscisse
	ld	c,35			; c ordonne de notre couleur  afficher
	CALL_(putsprite)		; met le contenu de hl en b,c justement
	pop	hl			; restaure hl et bc
	pop	bc
	inc	c			; incrmente c et hl
	inc	hl
	djnz	coucou		; boucle pendant que b<>0

	ld	b,5			; boucle ds figures : mme principe
	ld	d,0			; que prcedemment
	ld	hl,TEXT_MEM+23	; pointe vers les figures
boucle_fig:
	push	bc
	push	hl
	ld	c,(hl)		; charge le numro de la figure dans c
	dec	c			; lui retranche 1
	sla	c			; le multiplie par 2 puis par 2 pour avoir le bon dcalage dans le
	sla	c			; tableau "msg_fig". Ceci vite un gd nombre de boucles...
	ld	b,0			; met 0 dans b
	ld	hl,msg_fig		; hl pointe vers la chane de caractre msg_fig
	add	hl,bc			; ajoute le dcalage calcul
	ld	c,d			; comme prcedemment on rcupre d dans c
	ld	a,c			; a=c
	sla	a			; a=2c
	sla	a			; a=4c
	sla	a			; a=8c
	sla	a			; a=16c
	add	a,c			; a=17c
	sla	c			; c=2c
	add	a,c			; a=19c
	add	a,3			; a=19c+3
	ld	c,a			; abscisse a
	ld	b,49			; ordonne b=49
	ld	($8215),bc		; coordonnes graphiques
	ld	b,4			; ! nombre de caractres  imprimer !
	ROM_CALL(D_LM_STR)	; fonction spciale et utile, la preuve, qui affiche b caractres
	pop	hl			; de la chane pointe par hl
	pop	bc			; restaure hl et bc
	inc	hl			; ...
	inc	d
	djnz	boucle_fig
	res	7,(iy+$14)
	ROM_CALL(DISP_GRAPH)	; affiche les changements
	ret

decryptage_carte:			; explicite
	ld	b,5			; 5 cartes  traiter
	ld	hl,TEXT_MEM		; pointe vers la premire carte
carte_suivante:
	ld	c,0			; c numro de la couleur
	ld	a,(hl)		; a numro de la figure
super_boucle:			; super nom !
	inc	c			; incrmente le numro de la couleur
	or	a			; rappelle a
	cp	14			; le compare  14
	jr	c,au_suivant	; si c'est infrieur strict, ie on a un numro de figure correct
	sub	13			; sinon on retranche 13 et on reboucle, ce qui va incrmenter la 
	jr	super_boucle	; couleur et tourner jusqu' temps d'avoir une figure correcte...
au_suivant:				; c'est bon. On a notre couleur et notre figure
	push	hl
	push	bc
	ld	hl,TEXT_MEM+23	; pointe l'adresse de la figure
	ld	(hasard),a		; mise en mmoire de la figure
	CALL_(mise_en_mem)	; le hasard parat ne pas avoir sa place ici mais c'est un argument de mise_en_mem
	pop	bc
	ld	hl,TEXT_MEM+18	; pointe l'adresse de la couleur
	ld	a,c
	ld	(hasard),a		; mise en mmoire de la couleur
	CALL_(mise_en_mem)
	pop	hl
	inc	hl			; pointe la carte suivante
	djnz	carte_suivante	; boucle pour les 5 cartes
	ret

mise_en_mem:			; met en mmoire (hasard)  l'adresse hl
	ld	a,5			; calculs lourdingues qui seront corrigs quand j'aurai une 
	sub	b			; imprimante (impossible de faire des sources optimises sans un
	ld	c,a			; support crit) => qu'est ce que vous attendez pour m'envoyer
	push	bc			; de l'argent :-]
	ld	c,a			; bon ben c'est trs simple a vous trouvez pas ?
	ld	b,0
	add	hl,bc
	pop	bc
	ld	a,(hasard)
	ld	(hl),a
	ret

affich_hold:			; facile !
	ld	hl,msg_hold
	jp	affich
affich_rien:
	ld	hl,msg_rien
affich:
	dec	c
	ld	a,c			; c=a
	sla	a			; a=2c
	sla	a			; a=4c
	sla	a			; a=8c
	sla	a			; a=16c
	add	a,c			; a=17c
	sla	c			; c=2c
	add	a,c			; a=19c
	add	a,2			; a=19c+2
	ld	d,57			; ordonne=57
	ld	e,a			; abscisse=a
	ld	($8215),de
	set	7,(iy+$14)
	ROM_CALL(D_ZM_STR)
	res	7,(iy+$14)
	ROM_CALL(DISP_GRAPH)
	ret

random:				; nouvelle procdure de tirage au hasard
	push	bc			; inspire de la procdure Rand de Chris Busch
random2:				; la variable randvar est initialise avec le
	ld	a,(randvar)		; compteur APD au dbut du prog... Merci  Cory
	ld	b,a			; Crooks pour cette ide...
	ld	a,0
	add	a,b
	sla	b
	sla	b
	add	a,b
	sla	b
	sla	b
	add	a,b
	inc	a
	ld	(randvar),a
	srl	a
	inc	a
	ld	d,a
	cp	53
	jr	nc,random2

	ld	hl,TEXT_MEM+54	; vrifie s'il y a encore assez de cartes  tirer.
	ld	b,52			; 52 cartes  tester
	ld	c,0			; c=notre compteur
verifie_jeu_vide:
	inc	hl			; on place notre pointeur
	ld	a,(hl)
	cp	0			; ds qu'il y a au moins une carte non tire, c'est bon
	jr	z,pas_vide
	inc	c			; sinon on incrmente notre compteur
	djnz	verifie_jeu_vide	; boucle
	ld	a,c			; teste s'il y a 52 cartes qui ont
	cp	52			; t tires
	jp	nz,pas_vide		; si les 52 cartes n'ont pas t tires, goto plus bas
	CALL_(nettoie_le_jeu)	; si oui, on reset le jeu de carte
	JUMP_(random2)		; et on retire une carte

pas_vide:
	ld	hl,TEXT_MEM+54
	ld	b,d
place_hl:				; place le pointeur en fonction de d (carte tire)
	inc	hl
	djnz	place_hl
verifie_cartes_tirees:		; compare l'lement du tableau point par hl
	ld	a,(hl)		; s'il est gal  1, on retire une carte
	cp	1			; sinon on met
	jr	z,random2		; un 1
	ld	a,1			; dans 
	ld	(hl),a		; cet 
	ld	a,d			; lment
	pop	bc			; dpile bc
	ret

nettoie_le_jeu:			; simple - met des 0 dans tous les 
	ld	b,53			; lments du tableau
	ld	hl,TEXT_MEM+55	; jeu_de_cartes situ en TEXT_MEM+55
	ld	a,0
nettoie:
	ld	(hl),a
	inc	hl
	djnz	nettoie
	ret

ecran_jeu:				; affiche le squelette du jeu
	CALL_(efface_mem)		; efface la mmoire graphique
	ld	d,0			; trace plein de lignes
	CALL_(prem_loop)		; ...
	ld	d,18
	CALL_(prem_loop)
	ld	d,19
	CALL_(prem_loop)
	ld	d,37
	CALL_(prem_loop)
	ld	d,38
	CALL_(prem_loop)
	ld	d,56
	CALL_(prem_loop)
	ld	d,57
	CALL_(prem_loop)
	ld	d,75
	CALL_(prem_loop)
	ld	d,76
	CALL_(prem_loop)
	ld	d,94
	CALL_(prem_loop)
	ld	d,7
	CALL_(prem_loop2)
	ld	d,30
	CALL_(prem_loop2)
	ld	hl,decoration	; affiche la dcoration du dessus
	CALL_(putimage)
	ROM_CALL(DISP_GRAPH)	; affiche tout cela en 1 fois, pour garder une certaine rapidit
	ret				; du jeu, sinon a ressemble  du TI-Basic ;)

efface_mem:				; le nom est objectif
	ld	b,192			; il y a 192 * 4 octets  remplir de 0
	ld	hl,GRAPH_MEM	; je vous laisse dcrypter cela
eff:
	push	bc
	ld	b,4
copy:
	ld	(hl),0
	inc	hl
	djnz	copy
	pop	bc
	djnz	eff
	ret

; Merci  Dines Justesen pour ces quelques routines :

presentation:			; cran de prsentation : une image en 4 niveaux de gris :
					; il faut donc ln(4)/ln(2)=2 images (pour 8 niveaux de gris, ln(8)/ln(2)=3 images...)
					; qu'on affiche respectivement 1/3 et 2/3 du temps :
					; noir = 3/3, gris fonc = 2/3, gris clair = 1/3, blanc = 0/3 du temps total
	show_pic(poids_fort)	; affiche l'image de poids fort (show_pic est une macro dfinie au dbut)
	show_pic(poids_fort)	; ---------------------------------
	show_pic(poids_faible)	; -------------------------faible
	jr	presentation	; boucle
exit:					; si on a press une touche
	ret				; on retourne
; Je vous avoue que pour ce qui suit, je perds les pdales. Ce dont je ne suis pas sr est
; marqu d'un '*'. C'est surtout la fonction out que je ne comprends pas. J'essaierai de me
; renseigner :)
show_picture:			; on affiche l'image
	di				; Disables Interrupts => pas d'interruption => prog rapide
	ld	a,7			; met 7 dans a
	call	DISP_DELAY		; delai pour l'cran
	out	($10),a		; * met l'cran  jour ($10 est le port de l'cran)
	ld	a,$80			; * met 128 dans a (va  gauche)

line_loop:
	ld	d,a			; sauve a dans d (numro de colonne)
	call	DISP_DELAY		; dlai pour l'affichage (a fait une petite pause avant
					; d'afficher l'cran)
	out	($10),a		; * envoie 00000111  l'cran : slectionne le numro de ligne
	ld	a,$20			; * va en haut
	call	DISP_DELAY		; idem ci dessus
	out	($10),a		; *
	ld	bc,$0C11		; b=12, c=$11=port pour les donnes du contrleur d'affichage
write_loop:				; boucle d'criture (!)
	neg				; pour passer le temps je pense, ces quatre expressions
	neg
	neg
	neg
	outi				; incrmente l'adresse qu'on pointe avec hl et dcrmente b et
					; envoie au port $11 (donnes vido) le contenu de hl
	jr	nz,write_loop	; boucle tant que b<>0
	ld	a,d			; rappelle en d le numro de colonne
	inc	a			; incrmente a
	cp	$C0			; compare  192
	jr	nz,line_loop	; si c'est pas gal, on boucle, si oui on sort
	ei				; Enables Interrupts => retour  la normale ct interruptions
	ret

putpixel:				; affiche un pixel (hl contient l'adresse du dessin)
	call	FIND_PIXEL		; donne l'tat du pixel (b,c)  l'cran
	ld	de,GRAPH_MEM	; on charge en de la mmoire graphique
	add	hl,de			; on ajoute de  hl
	or	(hl)			; fait un OU entre (hl) et ce qu'il y a  l'cran
					; ("a" retourn par FIND_PIXEL) et le stocke en a
	ld	(hl),a		; on remet a en (hl)
	ret

; Merci  Jimmy Mrdell pour ces routines :
putsprite:				; affiche un sprite  l'cran (traduction IN-TROU-VABLE)
	push	bc			; sauvegarde bc et de
	push	de
	ld	a,63
	sub	c
	ld	c,a			; met en c 63-c
	push	hl			; sauve hl 2 fois - hl est la position du sprite  aficher
	push	hl
	call	FIND_PIXEL		; retourne en hl le dcalage dans la mmoire vido du pixel b,c
					; (en octets donc) et en a le bit  changer (ex. bit 3  changer :
					; a=2^3...). Trs utilis, c'te fonction
	ld	de,GRAPH_MEM	; de pointe la mmoire graphique
	add	hl,de			; rajoute le dcalage via hl
	ex	de,hl			; change pour retrouver notre valeur en de
	pop	hl			; restaure hl
	ld	b,(hl)		; met en b la largeur du sprite
	inc	hl			; et en c
	ld	c,(hl)		; sa hauteur
	inc	hl			; hl pointe maintenant les donnes du sprite
	push	hl			; sauvegarde
	pop	ix			; restaure en ix le contenu de bc
	ex	de,hl			; change de et hl
ps_newrow:				; nouvelle range
	push	bc			; sauve bc
	ld	d,(ix)		; charge d avec le contenu de ix
	inc	ix			; incrmente l'adresse pointe par ix
	push	af			; sauve af et hl
	push	hl
ps_newcol:				; nouvelle colonne
	rl	d			; fait une rotation vers la gauche de d
	ld	e,a			; met en e le numro du bit  changer
	jr	nc,ps_nopixel	; si la rotation n'a pas caus de changement du Carry Flag,
					; il n'y a pas de pixel  afficher
	or	(hl)			; sinon il y en a un : fait un or entre ce qui est affich
	ld	(hl),a		;  l'cran et ce qu'on veut (en l'occurence afficher un pixel)
	jr	ps_nextpixel	; va au pixel suivant
ps_nopixel:				; on veut ici effacer le pixel
	cpl				; on complmente a
	and	(hl)			; fait un et entre a et (hl) (teint en fait juste le pixel adquat)
	ld	(hl),a		; mmorise le rsultat
ps_nextpixel:			; pixel suivant
	ld	a,e			; remet dans a la valeur initiale du bit  changer
	rrca				; rotation de a vers la droite en activant le retenue s'il y a un 1
					; qui est transfr d'un bout  l'autre
	jr	nc,ps_samebyte	; si CY n'est pas activ, c'est qu'on est dans le mme octet
	inc	hl			; sinon on incrmente la mmoire graphique d'un octet
ps_samebyte:			; mme octet
	djnz	ps_newcol		; boucle pour faire une nouvelle colonne
	pop	hl			; restaure hl et af
	pop	af			; (a contient le bit  changer) (est-ce que a sert => si vous avez
					; envie d'essayer, ne vous gnez pas !)
	ld	de,12			; met 12 octets dans de
	add	hl,de			; ce qui permet de faire un dcalage d'une ligne sur hl
	pop	bc			; restaure bc
	dec	c			; dcrmente la hauteur c
	jr	nz,ps_newrow	; si la hauteur n'est pas nulle, boucle pour une nouvelle ligne
	pop	hl			; restaure hl, de et bc
	pop	de
	pop	bc
	ret				; retourne

prem_loop:				; procdure qui affiche une ligne verticale
	ld	b,23			; on met b  30 (ordonne max)
	ld	c,7			; on met c  7 (ordonne minimale)
sec_loop:				; boucle
	push	bc			; on sauvegarde bc
	ld	b,d			; on met d dans b
	push	de			; on sauvegarde de
	CALL_(putpixel)		; on affiche le pixel (b,c)
	pop	de			; on redonne  d et e leurs valeurs prcdentes
	pop	bc			;      "       b  " c           "
	inc	c			; on incrmente c
	djnz	sec_loop		; on dcrmente b jusqu' 0
	ret

prem_loop2:				; procdure qui affiche une ligne horizontale
	ld	b,95			; on met b  64
	ld	c,0			; on met c, le complment  64 de b
sec_loop2:				; boucle
	push	bc			; on sauvegarde bc
	ld	c,d			; on met d dans b
	push	de			; on sauvegarde de
	dec	b
	CALL_(putpixel)		; on affiche le pixel (b,c)
	pop	de			; on redonne  d et e leurs valeurs prcdentes
	pop	bc			;      "       b  " c           "
	inc	c			; on incrmente c
	djnz	sec_loop2		; on dcrmente b jusqu' 0
	ret

; Merci  Jimmy Mrdell pour ces routines :
putimage:				; affiche l'image stocke en hl
	ld	e,(hl)		; de contient l'adresse o placer l'image (avec l'offset)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	b,(hl)		; b est la largeur de l'image
	inc	hl			
	ld	c,(hl)		; c est la hauteur de l'image
	inc	hl
pi_newrow:
	push	bc
	push	de
pi_newcol:
	ld	a,(hl)		; a contient le i octet de l'image
	inc	hl			; on incrmente hl
	ld	(de),a		; on met dans l'endroit de la mmoire graphique
	inc	de			; on incrmente cette adresse
	djnz	pi_newcol		; continue la ligne
	pop	de			; redonne  de sa valeur
	ld	bc,12			; 12 est la largeur de l'cran en octets
	ex	de,hl			; change hl et de
	add	hl,bc			; hl est maintenant l'endroit du dbut de l'image pose + 12 octets, soit une ligne en dessous
	ex	de,hl			; remet hl en de (l'change tait l pour permettre l'addition 16 bits directement)
	pop	bc			; redonne  bc sa valeur initiale (avec la hauteur et la largeur)
	dec	c			; la hauteur se rduit
	jr	nz,pi_newrow	; si c n'est pas gale  0, boucle
	ret

; Cette procdure est trs inspire de celle de Jimmy Mrdell, "INPUT". Merci  lui once again
entree_nom:				; pour rentrer ton nom si t'es le plus beau et le plus fort
	push	hl			; sauve la position moins_bon+2 en hl
	ROM_CALL(CLEARLCD)	; c'est dur !
	set	3,(iy+$5)		; pour crire en blanc sur noir
	ld	hl,$0000		; curseur
	ld	($800C),hl		; texte
	ld	hl,msg_bravo	; message
	ROM_CALL(D_ZT_STR)	; l'affiche
	res	3,(iy+$5)		; remet en noir sur blanc
	ld	hl,$0304		; charge la nouvelle position
	ld	($800C),hl		; du curseur texte
	pop	hl			; restaure hl
	ld	e,0			; compte le nombre de lettres rentres
attendre_touche:
	push	hl			; sauvegarde la position car GET_KEY utilise hl
	call	GET_KEY		; explicite
	cp	$38			; touche DEL : revient en arrire
	jr	z,retour
	cp	$09			; touche entre : nom=ok
	jr	z,nom_ok
	or	a			; rappelle a
	jr	nz,saisie_lettre	; si on avait appuy sur une touche on va la traiter
	pop	hl			; restitue la position en mmoire du nom du dernier high-score
	jr	attendre_touche	; boucle
saisie_lettre:
	ld	hl,lettres		; pointe sur le tableau de correspondance entre touches->lettres
	ld	bc,26			; il y a 26 lettres  comparer
	cpir				; compare le truc point par hl avec a (notre touche tape)
					; jusqu' temps que bc=0 ou que (hl)=a
	ld	d,c			; si on trouve la lettre, c est l'index de cette lettre
	pop	hl			; hl=position dans la chane
	jr	nz,attendre_touche; si on n'a pas eu d'galit avec une quelconque touche
					; ie Z=0 <=> NZ=1, on retourne saisir une touche
	ld	a,65			; 65 est le code ASCII de A
	add	a,d			; a contient le code ASCII de la bonne lettre (index+dcalage ASCII)
mettre_lettre:
	ld	c,a			; c contient le lettre  afficher, enfin son code...
	ld	a,9			; nombre maximal de lettres pour le nom
	cp	e			; le compare  la taille du nom dj inscrit
	jr	z,attendre_touche	; s'il y a dix letttres affiches, retourne plus haut
	ld	(hl),c		; sinon mmorise la lettre
	inc	hl			; pointe la lettre suivante
	inc	e			; incrmente le compteur de lettres
	ld	a,c			; restitue  a la lettre  afficher
	ROM_CALL(TX_CHARPUT)	; l'affiche
	jr	attendre_touche	; retourne  la saisie de touches
retour:
	pop	hl			; restitue  hl l'adresse qu'il pointait (le nom du joueur)
	ld	a,e			; charge dans l'accumulateur le compteur de lettres affiches
	or	a			; regarde si le nombre de lettres affiches est gal  0
	jr	z,attendre_touche	; si tel est le cas le retour est impossible donc on retourne en haut
	dec	e			; dcrmente le nombre de lettres entres
	dec	hl			; et l'adresse pointe
	push	hl			; sauve cette adresse
	ld	hl,$800D		; hl pointe le curseur texte (x)
	dec	(hl)			; dcrmente (hl) donc x
	ld	a,32			; affiche un espace au dessus des autres caractres
	ROM_CALL(TX_CHARPUT)	; l'affiche
	dec	(hl)			; dcrmente le curseur texte
	pop	hl			; restaure hl
	jr	attendre_touche	; attend une nouvelle touche
nom_ok:
	pop	hl			; hl position actuelle dans le nom du joueur
	ld	(hl),0		; affiche un zro NECESSAIRE  la fin de la chane
	ret				; retourne, idiot !

; Voici l'interface entre numro de touche et lettre correspondante

lettres:
	.db $1A,$22,$2A			; Z Y X
	.db $0B,$13,$1B,$23,$2B		; W V U T S
	.db $0C,$14,$1C,$24,$2C		; R Q P O N
	.db $0D,$15,$1D,$25,$2D		; M L K J I
	.db $0E,$16,$1E,$26,$2E		; H G F E D
	.db $1F,$27,$2F			; C B A

attendre:				; simple n'est-ce pas ?
	call	GET_KEY
	or	a
	jr	z,attendre
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;              Donnes (bien lourdes pour certaines)                  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

msg_bravo:
	.db	" Bravo, t`as un "
	.db	"  high-score !  "
	.db	" Ton nom stp... ",0
msg_fin1:
	.db	"ENTER  Rejouer",0
msg_fin2:
	.db	"MODE Quitter",0
msg_meilleurs:
	.db	"Meilleurs Scores",0
msg_hold:
	.db	"Hold",0
msg_rien:
	.db	"               ",0
msg_score:
	.db	"Score:",0
msg_resultat:
	.db	"Resultat:",0
msg_coup:
	.db	"Coup:",0
msg_mise:
	.db	"Mise:",0
msg_gain:
	.db	"Gain:",0
msg_fig:
	.db	"A   K   Q   J   10  9   8   "
msg_fig2:
	.db	"7   6   5   4   3   2      ",0
msg_paire:
	.db	"Paire",0
msg_dblpaire:
	.db	"Double paire",0
msg_brelan:
	.db	"Brelan",0
msg_full:
	.db	"Full",0
msg_carre:
	.db	"Carre",0
msg_quinte:
	.db	"Quinte",0
msg_quintecoul:
	.db	"Quinte & Couleur",0
msg_quinteroy:
	.db	"Quinte royale",0
msg_qroycoul:
	.db	"Q Royale & Couleur",0
msg_couleur:
	.db	"Couleur",0
msg_quedalle:
	.db	"Rien...",0
msg_prof:
	.db	"solve(cos X,X,0)"
	.db	"     1.570796327",0

hauts_scores:
	.db	$00,$00
	.db	"PERSONNE ",0
	.db	$00,$00
	.db	"PERSONNE ",0
	.db	$00,$00
	.db	"PERSONNE ",0
	.db	$00,$00
	.db	"PERSONNE ",0
moins_bon:
	.db	$00,$00
	.db	"PERSONNE ",0

pic_coeur:
	.db	8,7
	.db	%01101100
	.db	%11111110
	.db	%11111110
	.db	%11111110
	.db	%01111100
	.db	%00111000
	.db	%00010000

pic_carreau:
	.db	8,7
	.db	%00010000
	.db	%00111000
	.db	%01111100
	.db	%11111110
	.db	%01111100
	.db	%00111000
	.db	%00010000

pic_pique:
	.db	8,7
	.db	%00010000
	.db	%00111000
	.db	%01111100
	.db	%11111110
	.db	%11111110
	.db	%10010010
	.db	%00111000

pic_trefle:
	.db	8,7
	.db	%00111000
	.db	%00111000
	.db	%11111110
	.db	%11111110
	.db	%11111110
	.db	%00010000
	.db	%00111000

pic_init:
	.db	8,7
	.db	%00010000
	.db	%01111100
	.db	%11010110
	.db	%11010110
	.db	%11010110
	.db	%01111100
	.db	%00010000

decoration:
	.dw	$88B9
	.db	10,9
	.db	%00000001,%10001100,%00001101,%10011000,%00000000,%00000001,%11110000,%00011000,%00000000,%00000000
	.db	%00000001,%10001111,%01101101,%10000011,%11111100,%11100001,%10110011,%10011011,%00111001,%11000000
	.db	%00000001,%10001111,%01101101,%11011011,%01101101,%10110001,%10110110,%11011010,%01101101,%11000000
	.db	%00000001,%10000011,%01101101,%10011011,%01101101,%10110001,%10110110,%11011010,%01101101,%10000000
	.db	%00000001,%10000011,%01101101,%10011011,%01101101,%11110001,%11110110,%11011110,%01111101,%10000000
	.db	%00000001,%10000011,%01101101,%10011011,%01101101,%10000001,%10000110,%11011110,%01100001,%10000000
	.db	%00000001,%10000011,%01101101,%10011011,%01101101,%10110001,%10000110,%11011010,%01101101,%10000000
	.db	%00000001,%10000011,%01101101,%10011011,%01101101,%10110001,%10000110,%11011011,%01101101,%10000000
	.db	%00000001,%11100011,%11101101,%11011011,%01101100,%11100001,%10000011,%10011011,%00111001,%10000000

poids_fort:
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00011011,%00000011,%00110011,%00001100,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00011011,%00000011,%00110011,%00001100,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00011011,%00000011,%00110111,%11000000,%11111111,%11100001,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00000011,%00000011,%00110111,%11001100,%11111111,%11110011,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00000011,%00000011,%00110011,%00001100,%11000110,%00110110,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00000011,%00000011,%00110011,%00001100,%11000110,%00110111,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00000011,%00000011,%00110011,%00001100,%11000110,%00110111,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%01110000,%00000011,%10000111,%00110011,%00001100,%11000110,%00110110,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00111111,%10000001,%11111110,%00110011,%11001100,%11000110,%00110011,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%00011111,%10000000,%11111100,%00110001,%11001100,%11000110,%00110001,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111000
  .db %01000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00001000
  .db %01000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00001110
  .db %01001111,%11110000,%00000000,%00111111,%00000000,%00111110,%00011111,%00001111,%11111110,%00111111,%11100000,%00001110
  .db %01001000,%00011100,%00000000,%11000000,%11000000,%00100011,%00010001,%10001000,%00000110,%00100000,%00111000,%00001110
  .db %01001000,%00000110,%00000011,%00000000,%01110000,%00100011,%00100011,%00001000,%00000110,%00100000,%00011100,%00001110
  .db %01001000,%00000110,%00000110,%00000000,%00111000,%00100011,%01000110,%00001000,%00000110,%00100000,%00001100,%00001110
  .db %01001000,%11000011,%00000100,%00111110,%00011000,%00100011,%10001100,%00001000,%11111110,%00100011,%10000110,%00001110
  .db %01001000,%11100011,%00001000,%01111111,%00001100,%00100011,%10001100,%00001000,%11111110,%00100011,%11000110,%00001110
  .db %01001000,%11100011,%00001000,%11100001,%10001100,%00100011,%00011000,%00001000,%11000000,%00100011,%01000110,%00001110
  .db %01001000,%11100011,%00010001,%11000000,%11000110,%00100010,%00110000,%00001000,%11111110,%00100011,%01000110,%00001110
  .db %01001000,%11000011,%00010001,%10000000,%01000110,%00100010,%00110000,%00001000,%00000110,%00100011,%10001110,%00001110
  .db %01001000,%00000111,%00010001,%10000000,%01000110,%00100000,%01100000,%00001000,%00000110,%00100000,%00001100,%00001110
  .db %01001000,%00000110,%00010001,%10000000,%01000110,%00100000,%01100000,%00001000,%00000110,%00100000,%00111100,%00001110
  .db %01001000,%00001110,%00010001,%10000000,%01000110,%00100010,%00110000,%00001000,%11111110,%00100000,%00111000,%00001110
  .db %01001000,%11111100,%00010001,%10000000,%01000110,%00100010,%00110000,%00001000,%11111110,%00100011,%00011000,%00001110
  .db %01001000,%11111000,%00010000,%11000000,%10000110,%00100011,%00011000,%00001000,%11000000,%00100011,%10001100,%00001110
  .db %01001000,%11000000,%00001000,%01100001,%00001100,%00100011,%10001100,%00001000,%11000000,%00100011,%01000110,%00001110
  .db %01001000,%11000000,%00001100,%00111110,%00001100,%00100011,%10001100,%00001000,%11111110,%00100011,%01000011,%00001110
  .db %01001000,%11000000,%00000100,%00000000,%00011000,%00100011,%01000110,%00001000,%00000110,%00100011,%00100011,%00001110
  .db %01001000,%11000000,%00000111,%00000000,%00111000,%00100011,%00100011,%00001000,%00000110,%00100011,%00100011,%00001110
  .db %01001000,%11000000,%00000011,%11000000,%11110000,%00100011,%00010001,%10001000,%00000110,%00100011,%00010001,%10001110
  .db %01001111,%11000000,%00000000,%11111111,%11100000,%00111111,%00011111,%10001111,%11111110,%00111111,%00011111,%10001110
  .db %01001111,%11000000,%00000000,%00111111,%10000000,%00111111,%00001111,%11001111,%11111110,%00111111,%00001111,%11001110
  .db %01000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00001110
  .db %01000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00001110
  .db %01000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00001110
  .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110
  .db %00011111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110
  .db %00011111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%11100000,%00000000,%11100000,%11010000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00011001,%10011001,%01010010,%00110001,%00000100,%10111010,%10101100,%11010000,%00000000,%00000000
  .db %00000000,%00000000,%00010100,%01010001,%01010101,%01000000,%11001011,%11010010,%10100010,%10101000,%00000000,%00000000
  .db %00000000,%00000000,%00010101,%11010001,%01010101,%01000000,%00101010,%10010010,%10101110,%10111000,%00000000,%00000000
  .db %00000000,%00000000,%00010101,%01010001,%01010101,%01010001,%00101010,%10010010,%10101010,%10100000,%00000000,%00000000
  .db %00000000,%00000000,%00011001,%11010000,%11100010,%00110000,%11000100,%10011001,%01001110,%10011000,%00000000,%00000000
  .db %00000000,%00000000,%00010000,%00000000,%01000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00001111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11110000,%00000000
  .db %00000000,%00001000,%00000000,%11111111,%11111111,%11111011,%11111110,%11111111,%11111111,%00000000,%00010000,%00000000
  .db %00000000,%00001000,%00000000,%11111111,%11111111,%10111111,%10001111,%11111111,%11101111,%00000000,%00010000,%00000000
  .db %00000000,%00001000,%00000000,%10011000,%10001101,%10011011,%01010110,%10010110,%01000101,%00000000,%00010000,%00000000
  .db %00000000,%00001000,%00000000,%11101010,%10101010,%10101010,%10101010,%10101010,%11101010,%00000000,%00010000,%00000000
  .db %00000000,%00001000,%00000000,%10001010,%10101000,%10101010,%10101010,%10100011,%01101000,%00000000,%00010000,%00000000
  .db %00000000,%00001000,%00000000,%10101010,%10101011,%10101010,%11000110,%10101111,%10101011,%00000000,%00010000,%00000000
  .db %00000000,%00001000,%00000000,%10001010,%10101100,%10011011,%01111010,%10110010,%01100100,%00000000,%00010000,%00000000
  .db %00000000,%00001000,%00000000,%11111111,%11111111,%11111111,%10000111,%11111111,%11111111,%00000000,%00010000,%00000000

poids_faible:
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00011011,%00000011,%00110011,%00001100,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00011011,%00000011,%00110011,%00001100,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00011011,%00000011,%00110111,%11000000,%11111111,%11100001,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00000011,%00000011,%00110111,%11001100,%11111111,%11110011,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00000011,%00000011,%00110011,%00001100,%11000110,%00110110,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00000011,%00000011,%00110011,%00001100,%11000110,%00110111,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%01100000,%00000011,%00000011,%00110011,%00001100,%11000110,%00110111,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%01110000,%00000011,%10000111,%00110011,%00001100,%11000110,%00110110,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00111111,%10000001,%11111110,%00110011,%11001100,%11000110,%00110011,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%00011111,%10000000,%11111100,%00110001,%11001100,%11000110,%00110001,%11110000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111000
  .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111000
  .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110
  .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111010
  .db %01111000,%00011111,%11111111,%11000000,%11111111,%11100011,%11110001,%11111000,%00000111,%11100000,%00111111,%11111010
  .db %01111000,%00000111,%11111111,%00000000,%01111111,%11100011,%11100011,%11111000,%00000111,%11100000,%00011111,%11111010
  .db %01111000,%00000111,%11111110,%00000000,%00111111,%11100011,%11000111,%11111000,%00000111,%11100000,%00001111,%11111010
  .db %01111000,%11000011,%11111100,%00111110,%00011111,%11100011,%10001111,%11111000,%11111111,%11100011,%10000111,%11111010
  .db %01111000,%11100011,%11111000,%01111111,%00001111,%11100011,%10001111,%11111000,%11111111,%11100011,%11000111,%11111010
  .db %01111000,%11100011,%11111000,%11111111,%10001111,%11100011,%00011111,%11111000,%11111111,%11100011,%11000111,%11111010
  .db %01111000,%11100011,%11110001,%11111111,%11000111,%11100010,%00111111,%11111000,%11111111,%11100011,%11000111,%11111010
  .db %01111000,%11000011,%11110001,%11111111,%11000111,%11100010,%00111111,%11111000,%00000111,%11100011,%10001111,%11111010
  .db %01111000,%00000111,%11110001,%11111111,%11000111,%11100000,%01111111,%11111000,%00000111,%11100000,%00001111,%11111010
  .db %01111000,%00000111,%11110001,%11111111,%11000111,%11100000,%01111111,%11111000,%00000111,%11100000,%00111111,%11111010
  .db %01111000,%00001111,%11110001,%11111111,%11000111,%11100010,%00111111,%11111000,%11111111,%11100000,%00111111,%11111010
  .db %01111000,%11111111,%11110001,%11111111,%11000111,%11100010,%00111111,%11111000,%11111111,%11100011,%00011111,%11111010
  .db %01111000,%11111111,%11110000,%11111111,%10000111,%11100011,%00011111,%11111000,%11111111,%11100011,%10001111,%11111010
  .db %01111000,%11111111,%11111000,%01111111,%00001111,%11100011,%10001111,%11111000,%11111111,%11100011,%11000111,%11111010
  .db %01111000,%11111111,%11111100,%00111110,%00001111,%11100011,%10001111,%11111000,%11111111,%11100011,%11000011,%11111010
  .db %01111000,%11111111,%11111100,%00000000,%00011111,%11100011,%11000111,%11111000,%00000111,%11100011,%11100011,%11111010
  .db %01111000,%11111111,%11111111,%00000000,%00111111,%11100011,%11100011,%11111000,%00000111,%11100011,%11100011,%11111010
  .db %01111000,%11111111,%11111111,%11000000,%11111111,%11100011,%11110001,%11111000,%00000111,%11100011,%11110001,%11111010
  .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111010
  .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111010
  .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111010
  .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111010
  .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111010
  .db %01111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111010
  .db %00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000010
  .db %00011111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111110
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000,%11100000,%00000000,%11100000,%11010000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00011001,%10011001,%01010010,%00110001,%00000100,%10111010,%10101100,%11010000,%00000000,%00000000
  .db %00000000,%00000000,%00010100,%01010001,%01010101,%01000000,%11001011,%11010010,%10100010,%10101000,%00000000,%00000000
  .db %00000000,%00000000,%00010101,%11010001,%01010101,%01000000,%00101010,%10010010,%10101110,%10111000,%00000000,%00000000
  .db %00000000,%00000000,%00010101,%01010001,%01010101,%01010001,%00101010,%10010010,%10101010,%10100000,%00000000,%00000000
  .db %00000000,%00000000,%00011001,%11010000,%11100010,%00110000,%11000100,%10011001,%01001110,%10011000,%00000000,%00000000
  .db %00000000,%00000000,%00010000,%00000000,%01000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00010000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
  .db %00000000,%00001111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%11110000,%00000000
  .db %00000000,%00001111,%11111111,%00000000,%00001111,%11111011,%11111110,%11110000,%00000000,%11111111,%11110000,%00000000
  .db %00000000,%00001111,%11111011,%00000000,%00001111,%10111111,%10001111,%11110000,%00000000,%11100111,%11110000,%00000000
  .db %00000000,%00001111,%10001000,%00000000,%00001101,%10011011,%01010110,%10010000,%00000000,%11101001,%11110000,%00000000
  .db %00000000,%00001111,%10101010,%00000000,%00001010,%10101010,%10101010,%10100000,%00000000,%11000011,%11110000,%00000000
  .db %00000000,%00001111,%10101010,%00000000,%00001000,%10101010,%10101010,%10100000,%00000000,%11101011,%11110000,%00000000
  .db %00000000,%00001111,%10101010,%00000000,%00001011,%10101010,%11000110,%10100000,%00000000,%11101011,%11110000,%00000000
  .db %00000000,%00001111,%10101010,%00000000,%00001100,%10011011,%01111010,%10110000,%00000000,%10101011,%11110000,%00000000
  .db %00000000,%00001111,%11111111,%00000000,%00001111,%11111111,%10000111,%11110000,%00000000,%11111111,%11110000,%00000000

.end
.end